"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.booleanizeTypes = void 0;
var logic_1 = require("./logic");
var console_messages_1 = require("../../../../cli/console/console.messages");
var booleanizeTypes = function (name, types, objectsName, booleanize, depth) {
    if (depth === void 0) { depth = 0; }
    var properties = (0, logic_1.getTypeProperties)(name, types);
    if (!properties) {
        return '';
    }
    var output = properties.reduce(function (acc, property) {
        var _a = __read(property.split(':'), 2), name = _a[0], type = _a[1];
        var maybeArrayAnnotation = (0, logic_1.getMaybeArrayAnnotation)(booleanize, type);
        var rawType = (0, logic_1.getRawType)(type);
        if (objectsName.includes(rawType)) {
            if (depth < 9) {
                return (acc +
                    ("".concat(name).concat(booleanize && !name.endsWith('?') ? '?' : '', ": ") +
                        (0, exports.booleanizeTypes)(rawType, types, objectsName, booleanize, ++depth) +
                        maybeArrayAnnotation +
                        ';'));
            }
            (0, console_messages_1.displayWarning)('Deeply nested type detected. Depth is limited to 9; falling back to type unknown');
            return "".concat(name, ": unknown");
        }
        return (0, logic_1.format)(acc, property, booleanize, type, maybeArrayAnnotation);
    }, '');
    return "{ ".concat(output, " }");
};
exports.booleanizeTypes = booleanizeTypes;
